/*
 * File:   CircularQueue.c
 * Author: Bob
 *
 * Created on November 23, 2014, 5:20 PM
 */

#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include "CircularQueue.h"

void CircularQueue_Create(struct CircularQueue *queue, char *buffer, size_t queueSize)
{
    queue->queueSize = queueSize;
    queue->head = queue->tail = 0;
    queue->queue = buffer;
};

bool CircularQueue_Read(struct CircularQueue *queue, char *itemBuf)
{
    if (queue->head == queue->tail)
        return false;
    *itemBuf = queue->queue[queue->head];
    if (++queue->head == queue->queueSize)
        queue->head = 0;
    return true;
}

bool CircularQueue_Write(struct CircularQueue *queue, char data)
{
    size_t newTail = queue->tail + 1;
    if (newTail == queue->queueSize)
        newTail = 0;
    // Check whether the queue is full
    if (newTail == queue->head)
        return false;
    queue->queue[queue->tail] = data;
    queue->tail = newTail;
}

bool CircularQueue_IsEmpty(struct CircularQueue *queue)
{
    return (queue->head == queue->tail);
}

bool CircularQueue_IsFull(struct CircularQueue *queue)
{
    size_t nextTail = queue->tail + 1;
    if (nextTail == queue->queueSize)
        nextTail = 0;
    // Check whether the queue is full
    return (nextTail == queue->head);
}
